#!/usr/bin/env python
# -*- coding: utf-8 -*-

''' Truncation Selection '''

from random import randint

from ...plugin_interfaces.operators.selection import GASelection

class TruncationSelection(GASelection):
    def __init__(self, trunc=2):
        '''
        Selection operator truncation selection implementation.
        '''
        self.trunc = trunc
        pass

    def select(self, population, fitness):
        '''
        Select a pair of parent using a proportion 1/trunc.
        '''
        sortedindvs = sorted(population.individuals, key=fitness, reverse=True)
        selectedub = len(sortedindvs) / self.trunc

        father_idx = randint(0, selectedub)
        father = sortedindvs[father_idx]

        mother_idx = father_idx
        maxmarriage = 10
        # Consanguineous marriage should be forbidden in best effort.
        while selectedub > 0 and maxmarriage > 0 and father.isEqual(sortedindvs[mother_idx]):
            mother_idx = randint(0, selectedub)
            maxmarriage -= 1
            pass
        #mother_idx = randint(0, selectedub)
        mother = sortedindvs[mother_idx]

        return father, mother

